import numpy as np
import pylab as pl

outputFileFormat = 'pdf'

def plotSingleFile(filename):
	
	data = np.loadtxt(filename, skiprows=1) #loads the data with built-in method, but skips the first rows


	pl.plot(data[:,0], dontPlotZero(data[:,1]), label="VBM")
	pl.plot(data[:,0], data[:,2], label="HGSADC")
	pl.axhline(y=10000, xmin=0,xmax=27, c="r", ls="--", label="Max. running time")
	pl.xlabel('Number of installations')
	pl.ylabel('Running time (s)')
	axes = pl.gca()
	ylim = axes.get_ylim()
	axes.set_xlim(xmin=0, xmax=27)
	axes.set_ylim(ymax=13000)#adjust the y-axis
	pl.legend(loc=1)
	
	
	pl.tight_layout()
	pl.savefig ("runningTimeComparisonPlot" +'.' + outputFileFormat, format = outputFileFormat, bbox_inches='tight')
	pl.close()
	return

def dontPlotZero(array):
	for i in range(len(array)-1):
		if array[i] == 0:
			array[i] = np.nan
	return array

plotSingleFile("runningTimeComparison.txt")